# coding: utf-8

"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class StatusAzureServiceBusSession(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sequence_number': 'int',
        'last_processed': 'datetime'
    }

    attribute_map = {
        'sequence_number': 'sequence_number',
        'last_processed': 'last_processed'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """StatusAzureServiceBusSession - a model defined in Swagger"""  # noqa: E501

        self._sequence_number = None
        self._last_processed = None
        self.discriminator = None

        self.sequence_number = kwargs.pop('sequence_number', None)
        self.last_processed = kwargs.pop('last_processed', None)

    @property
    def sequence_number(self):
        """Gets the sequence_number of this StatusAzureServiceBusSession.  # noqa: E501

        The last processed sequence number within this session  # noqa: E501

        :return: The sequence_number of this StatusAzureServiceBusSession.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this StatusAzureServiceBusSession.

        The last processed sequence number within this session  # noqa: E501

        :param sequence_number: The sequence_number of this StatusAzureServiceBusSession.  # noqa: E501
        :type: int
        """

        self._sequence_number = sequence_number

    @property
    def last_processed(self):
        """Gets the last_processed of this StatusAzureServiceBusSession.  # noqa: E501

        Most recent ISO-8601 date when a message from this session was processed  # noqa: E501

        :return: The last_processed of this StatusAzureServiceBusSession.  # noqa: E501
        :rtype: datetime
        """
        return self._last_processed

    @last_processed.setter
    def last_processed(self, last_processed):
        """Sets the last_processed of this StatusAzureServiceBusSession.

        Most recent ISO-8601 date when a message from this session was processed  # noqa: E501

        :param last_processed: The last_processed of this StatusAzureServiceBusSession.  # noqa: E501
        :type: datetime
        """

        self._last_processed = last_processed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StatusAzureServiceBusSession, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StatusAzureServiceBusSession):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

    def __getitem__(self, item):
        return getattr(self, item)

    def get(self, item):
        return getattr(self, item)

    def items(self):
        return self.to_dict().items()

    def __setitem__(self, item, value):
        return seattr(self, item, value)
